//LCD Screen code
#include <LiquidCrystal.h>
LiquidCrystal lcd(6,7,8,2,3,4,5);

//Shift register pins
int LATCH = 11;
int DATA = 12;
int CLOCK = 10;

//Button pins
int player1 = 14;
// PART 1.1: ADD player1
int player2 = 15;

boolean pressed_p1;
// PART 1.2: ADD pressed_p2
boolean pressed_p2;

// CREATE YOUR VARIABLES HERE!
// PART 3.1: CREATE THE VARIABLE CALLED gameSpeed
int gameSpeed = 500;
// PART 3.1: CREATE THE VARIABLE CALLED timeLimiit
int timeLimit = 3000;
// PART 3.1: CREATE THE VARIABLE CALLED timer
int timer;
// PART 8.1: CREATE THE VARIABLE CALLED winner
int winner;

void setup() {
  // Setting up the Led shift register
  pinMode(LATCH, OUTPUT);
  pinMode(DATA, OUTPUT);
  pinMode(CLOCK, OUTPUT);
  
  //Set up the LCD screen
  lcd.begin(16, 2);

  pinMode(player1, INPUT);
  // PART 1.3: REPEAT FOR PLAYER 2
  pinMode(player2, INPUT);
  digitalWrite(player1, HIGH);
  // PART 1.4: REPEAT FOR PLAYER 2
  digitalWrite(player2, HIGH);
}

void loop() {
  // PART 2.1 - 2.6: READY SET GO!
  lcd.clear();
  lcd.setCursor(0,0);
  lcd.print("READY!");
  delay(700);
  lcd.clear();
  lcd.setCursor(0,0);
  lcd.print("SET!");
  delay(700);
  lcd.clear();
  lcd.setCursor(0,0);
  lcd.print("GO!");
  lcd.setCursor(0,1);
  lcd.print("P1     |     P2");
  delay(700);
  
  while(true){
    // PART 3.2: LIGHTS GO FROM RIGHT TO LEFT
    displayBinary(1);
    delay(gameSpeed);
    displayBinary(2);
    delay(gameSpeed);
    displayBinary(4);
    delay(gameSpeed);
    displayBinary(8);
    delay(gameSpeed);
    displayBinary(16);
    delay(gameSpeed);
    displayBinary(32);
    delay(gameSpeed);
    displayBinary(64);
    delay(gameSpeed);
    displayBinary(128);

    // PART 4.4: SET timer TO 0 
    timer = 0;
    // PART 5.1: SET pressed_p1 TO false
    pressed_p1 = false;
    
    // PART 4.5 - 4.7 and 5.2 - 5.4: MAKE AND EDIT YOUR WHILE LOOP CODE HERE
    while ((timer < timeLimit) && (pressed_p1 == false)){
      if(digitalRead(player1) == LOW) {
        pressed_p1 = true;
      }
      delay(1);
      timer = timer + 1;
    }
    
    //PART 8.2 - 8.4: CHECK IF TIME RAN OUT, PUT YOUR IF STATEMENT HERE:
    if (timer == timeLimit){
      winner = 2;
      break;
    }
      
    // PART 3.3: LIGHTS GO FROM LEFT TO RIGHT
    displayBinary(128);
    delay(gameSpeed);
    displayBinary(64);
    delay(gameSpeed);
    displayBinary(32);
    delay(gameSpeed);
    displayBinary(16);
    delay(gameSpeed);
    displayBinary(8);
    delay(gameSpeed);
    displayBinary(4);
    delay(gameSpeed);
    displayBinary(2);
    delay(gameSpeed);
    displayBinary(1);
    
    // PART 6.2: COPY YOUR CODE FROM THE WHILE LOOP ABOVE TO HERE AND UPDATE IT FOR PLAYER 2
    //Show the last light
    pressed_p2 = false;
    //Wait until button is pressed
    timer = 0;
    while ((pressed_p2 == false) && (timer < timeLimit)){
      if(digitalRead(player2) == LOW) {
        pressed_p2 = true;
      }
      timer = timer + 1;
      delay(1);
    }
    
    //PART 8.6: REPEAT WHAT YOU DID FOR 8.2 - 8.4 HERE FOR THE OTHER PLAYER
    if (timer == timeLimit){
      winner = 1;
      break;
    } 
  }
  
  // PART 2.7 - 2.8: GAMAE OVER!
  lcd.clear();
  lcd.setCursor(0,0);
  lcd.print("GAME OVER!"); 
  lcd.setCursor(0,1);
  delay(3000);
  
  // PART 8.7: PRINT WHO ONE HERE WITH AN IF/ELSE IF STATEMENT:
  if (winner==1){
    lcd.print("player 1 wins!"); 
  }
  else if (winner==2){
    lcd.print("Player 2 wins!"); 
  }
  delay(3000);
}



// this is a function which given a number will display it on the shift register
void displayBinary(int number) {
  // un-latch the shift register
  digitalWrite(LATCH, LOW);
  // write the data to the register
  shiftOut(DATA, CLOCK, LSBFIRST, number);
  // re-latch the shift register
  digitalWrite(LATCH, HIGH);
}
  
